# **********************************************************************
#
# Copyright (c) 2003-2008 ZeroC, Inc. All rights reserved.
#
# This copy of Ice is licensed to you under the terms described in the
# ICE_LICENSE file included in this distribution.
#
# **********************************************************************

# Ice version 3.3.0
# Generated from file `IceBox.ice'

require 'Ice'
require 'Ice/BuiltinSequences.rb'
require 'Ice/CommunicatorF.rb'
require 'Ice/PropertiesF.rb'
require 'Ice/SliceChecksumDict.rb'

module IceBox

    if not defined?(::IceBox::FailureException)
        class FailureException < Ice::LocalException
            def initialize(reason='')
                @reason = reason
            end

            def to_s
                'IceBox::FailureException'
            end

            def inspect
                return ::Ice::__stringifyException(self)
            end

            attr_accessor :reason
        end

        T_FailureException = ::Ice::__defineException('::IceBox::FailureException', FailureException, nil, [["reason", ::Ice::T_string]])
        FailureException::ICE_TYPE = T_FailureException
    end

    if not defined?(::IceBox::AlreadyStartedException)
        class AlreadyStartedException < Ice::UserException
            def initialize
            end

            def to_s
                'IceBox::AlreadyStartedException'
            end

            def inspect
                return ::Ice::__stringifyException(self)
            end
        end

        T_AlreadyStartedException = ::Ice::__defineException('::IceBox::AlreadyStartedException', AlreadyStartedException, nil, [])
        AlreadyStartedException::ICE_TYPE = T_AlreadyStartedException
    end

    if not defined?(::IceBox::AlreadyStoppedException)
        class AlreadyStoppedException < Ice::UserException
            def initialize
            end

            def to_s
                'IceBox::AlreadyStoppedException'
            end

            def inspect
                return ::Ice::__stringifyException(self)
            end
        end

        T_AlreadyStoppedException = ::Ice::__defineException('::IceBox::AlreadyStoppedException', AlreadyStoppedException, nil, [])
        AlreadyStoppedException::ICE_TYPE = T_AlreadyStoppedException
    end

    if not defined?(::IceBox::NoSuchServiceException)
        class NoSuchServiceException < Ice::UserException
            def initialize
            end

            def to_s
                'IceBox::NoSuchServiceException'
            end

            def inspect
                return ::Ice::__stringifyException(self)
            end
        end

        T_NoSuchServiceException = ::Ice::__defineException('::IceBox::NoSuchServiceException', NoSuchServiceException, nil, [])
        NoSuchServiceException::ICE_TYPE = T_NoSuchServiceException
    end

    if not defined?(::IceBox::Service_mixin)
        module Service_mixin

            #
            # Operation signatures.
            #
            # def start(name, communicator, args)
            # def stop()

            def inspect
                ::Ice::__stringify(self, T_Service)
            end
        end
        class Service
            include Service_mixin
            
            def Service.ice_staticId()
                '::IceBox::Service'
            end
        end

        if not defined?(::IceBox::T_Service)
            T_Service = ::Ice::__declareLocalClass('::IceBox::Service')
        end

        T_Service.defineClass(Service, true, nil, [], [])
        Service_mixin::ICE_TYPE = T_Service
    end

    if not defined?(::IceBox::ServiceObserver_mixin)
        module ServiceObserver_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::Object', '::IceBox::ServiceObserver']
            end

            def ice_id(current=nil)
                '::IceBox::ServiceObserver'
            end

            #
            # Operation signatures.
            #
            # def servicesStarted(services, current=nil)
            # def servicesStopped(services, current=nil)

            def inspect
                ::Ice::__stringify(self, T_ServiceObserver)
            end
        end
        class ServiceObserver
            include ServiceObserver_mixin
            
            def ServiceObserver.ice_staticId()
                '::IceBox::ServiceObserver'
            end
        end
        module ServiceObserverPrx_mixin

            def servicesStarted(services, _ctx=nil)
                ServiceObserver_mixin::OP_servicesStarted.invoke(self, [services], _ctx)
            end

            def servicesStopped(services, _ctx=nil)
                ServiceObserver_mixin::OP_servicesStopped.invoke(self, [services], _ctx)
            end
        end
        class ServiceObserverPrx < ::Ice::ObjectPrx
            include ServiceObserverPrx_mixin

            def ServiceObserverPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::IceBox::ServiceObserver', facetOrCtx, _ctx)
            end

            def ServiceObserverPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
        end

        if not defined?(::IceBox::T_ServiceObserver)
            T_ServiceObserver = ::Ice::__declareClass('::IceBox::ServiceObserver')
            T_ServiceObserverPrx = ::Ice::__declareProxy('::IceBox::ServiceObserver')
        end

        T_ServiceObserver.defineClass(ServiceObserver, true, nil, [], [])
        ServiceObserver_mixin::ICE_TYPE = T_ServiceObserver

        T_ServiceObserverPrx.defineProxy(ServiceObserverPrx, T_ServiceObserver)
        ServiceObserverPrx::ICE_TYPE = T_ServiceObserverPrx

        ServiceObserver_mixin::OP_servicesStarted = ::Ice::__defineOperation('servicesStarted', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, [::Ice::T_StringSeq], [], nil, [])
        ServiceObserver_mixin::OP_servicesStopped = ::Ice::__defineOperation('servicesStopped', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, [::Ice::T_StringSeq], [], nil, [])
    end

    if not defined?(::IceBox::ServiceManager_mixin)
        module ServiceManager_mixin
            include ::Ice::Object_mixin

            def ice_ids(current=nil)
                ['::Ice::Object', '::IceBox::ServiceManager']
            end

            def ice_id(current=nil)
                '::IceBox::ServiceManager'
            end

            #
            # Operation signatures.
            #
            # def getSliceChecksums(current=nil)
            # def startService(service, current=nil)
            # def stopService(service, current=nil)
            # def addObserver(observer, current=nil)
            # def shutdown(current=nil)

            def inspect
                ::Ice::__stringify(self, T_ServiceManager)
            end
        end
        class ServiceManager
            include ServiceManager_mixin
            
            def ServiceManager.ice_staticId()
                '::IceBox::ServiceManager'
            end
        end
        module ServiceManagerPrx_mixin

            def getSliceChecksums(_ctx=nil)
                ServiceManager_mixin::OP_getSliceChecksums.invoke(self, [], _ctx)
            end

            def startService(service, _ctx=nil)
                ServiceManager_mixin::OP_startService.invoke(self, [service], _ctx)
            end

            def stopService(service, _ctx=nil)
                ServiceManager_mixin::OP_stopService.invoke(self, [service], _ctx)
            end

            def addObserver(observer, _ctx=nil)
                ServiceManager_mixin::OP_addObserver.invoke(self, [observer], _ctx)
            end

            def shutdown(_ctx=nil)
                ServiceManager_mixin::OP_shutdown.invoke(self, [], _ctx)
            end
        end
        class ServiceManagerPrx < ::Ice::ObjectPrx
            include ServiceManagerPrx_mixin

            def ServiceManagerPrx.checkedCast(proxy, facetOrCtx=nil, _ctx=nil)
                ice_checkedCast(proxy, '::IceBox::ServiceManager', facetOrCtx, _ctx)
            end

            def ServiceManagerPrx.uncheckedCast(proxy, facet=nil)
                ice_uncheckedCast(proxy, facet)
            end
        end

        if not defined?(::IceBox::T_ServiceManager)
            T_ServiceManager = ::Ice::__declareClass('::IceBox::ServiceManager')
            T_ServiceManagerPrx = ::Ice::__declareProxy('::IceBox::ServiceManager')
        end

        T_ServiceManager.defineClass(ServiceManager, true, nil, [], [])
        ServiceManager_mixin::ICE_TYPE = T_ServiceManager

        T_ServiceManagerPrx.defineProxy(ServiceManagerPrx, T_ServiceManager)
        ServiceManagerPrx::ICE_TYPE = T_ServiceManagerPrx

        ServiceManager_mixin::OP_getSliceChecksums = ::Ice::__defineOperation('getSliceChecksums', ::Ice::OperationMode::Idempotent, ::Ice::OperationMode::Nonmutating, false, [], [], ::Ice::T_SliceChecksumDict, [])
        ServiceManager_mixin::OP_startService = ::Ice::__defineOperation('startService', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, [::Ice::T_string], [], nil, [::IceBox::T_AlreadyStartedException, ::IceBox::T_NoSuchServiceException])
        ServiceManager_mixin::OP_stopService = ::Ice::__defineOperation('stopService', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, [::Ice::T_string], [], nil, [::IceBox::T_AlreadyStoppedException, ::IceBox::T_NoSuchServiceException])
        ServiceManager_mixin::OP_addObserver = ::Ice::__defineOperation('addObserver', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, [::IceBox::T_ServiceObserverPrx], [], nil, [])
        ServiceManager_mixin::OP_shutdown = ::Ice::__defineOperation('shutdown', ::Ice::OperationMode::Normal, ::Ice::OperationMode::Normal, false, [], [], nil, [])
    end
end
